SystemOrganization addCategory: #BuscaMinas!

SimpleSwitchMorph subclass: #BMCell
	instanceVariableNames: 'mouseAction contenedor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BuscaMinas'!

!BMCell methodsFor: 'accessing' stamp: 'jameserazo 5/25/2012 11:25'!
contenedor

	^ contenedor! !

!BMCell methodsFor: 'accessing' stamp: 'jameserazo 5/25/2012 11:25'!
contenedor: anObject

	contenedor := anObject! !

!BMCell methodsFor: 'initialization' stamp: 'JamesErazo 5/18/2012 20:35'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@4 corner: 20@20.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff.! !

!BMCell methodsFor: 'initialization' stamp: 'jameserazo 5/25/2012 11:47'!
initialize: val
	contenedor:=val.
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@4 corner: 20@20.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff.! !

!BMCell methodsFor: 'accessing' stamp: 'jameserazo 5/25/2012 11:25'!
mouseAction

	^ mouseAction! !

!BMCell methodsFor: 'initialization' stamp: 'JamesErazo 5/18/2012 18:14'!
mouseAction: aBlock
	^mouseAction := aBlock! !

!BMCell methodsFor: 'accessing' stamp: 'jameserazo 5/25/2012 12:15'!
setLabel: val
	self label:val! !

SimpleSwitchMorph subclass: #BMPanel
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BuscaMinas'!

!BMPanel methodsFor: 'initialize' stamp: 'JamesErazo 5/18/2012 18:14'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 20@20.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff.
! !

!BMPanel methodsFor: 'access-ing' stamp: 'JamesErazo 5/18/2012 18:11'!
mouseAction: aBlock
	^mouseAction := aBlock! !

!BMPanel methodsFor: 'access-ing' stamp: 'jameserazo 5/25/2012 11:18'!
mouseUp: anEvent
	mouseAction value! !

BorderedMorph subclass: #BMGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BuscaMinas'!

!BMGame methodsFor: 'accessing' stamp: 'jameserazo 5/25/2012 11:27'!
cells

	^ cells! !

!BMGame methodsFor: 'accessing' stamp: 'jameserazo 5/25/2012 11:27'!
cells: anObject

	cells := anObject! !

!BMGame methodsFor: 'initialization' stamp: 'JamesErazo 5/18/2012 17:18'!
cellsPerSide
	"retorna el numero de filas y colomnas del tablero del juego - constante"
	^20
! !

!BMGame methodsFor: 'initialization' stamp: 'JamesErazo 5/18/2012 20:17'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := BMPanel new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width*n) @(height*n)) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ].
! !

!BMGame methodsFor: 'game-logic' stamp: 'jameserazo 5/25/2012 12:21'!
newCellAt: i at: j
	| c origin rnd|
	c := BMCell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j - 1+5) * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	rnd:= Random new.
	rnd:=(rnd nextValue )*1.
	rnd:=rnd asInteger rem: 2.
	c setLabel: rnd asString.
	c contenedor: rnd.
	^c
! !

!BMGame methodsFor: 'game-logic' stamp: 'JamesErazo 5/18/2012 16:55'!
toggleNeighboursOfCellAt: i at: j
	(i > 1) ifTrue: [ (cells at: i - 1 at: j ) toggleState].
	(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
	(j > 1) ifTrue: [ (cells at: i at: j - 1) toggleState].
	(j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState].
! !

!BMGame methodsFor: 'as yet unclassified' stamp: 'jameserazo 5/25/2012 11:38'!
ubicarMinas: objetvalor inx: x iny: y
		cells 		
! !
